#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "zinc.h"
/********************************************/
char **parsefunction(char **tokens)
{
	int a,b,t;
	a=lookupfunc(*tokens);
#ifdef VIEW
	printf("function call : %s\n", *tokens);
#endif
	tokens++;
	if (!strcmp(*tokens,"("))
	{
		for (b=0;b<funcs[a].vcount;b++) /* get all parameters */
		{
			tokens++;
			if (!strcmp(*tokens,",")) tokens++;
			printf("\tparameter %d - %s\n", b, *tokens);
			t=funcs[a].vars[b].type;
			if (t==lookuptype("hl"))
			{
				fprintf(out_asm, "\t ld hl, %s\n", *tokens);
			}
			else if (t==lookuptype("a"))
			{
				fprintf(out_asm, "\t ld a, %s\n", *tokens);
			}
			else if (z80sizeof(funcs[a].vars[a].name)==2)
			{
				fprintf(out_asm, "\t ld hl, %s\n", *tokens);
				fprintf(out_asm, "\t ld %s, hl\n", vartypes[t]);
			}
			else /* assume its 1 byte*/
			{
				fprintf(out_asm, "\t ld a, %s\n", *tokens);
				fprintf(out_asm, "\t ld %s, a\n", vartypes[t]);
			}

		}
		fprintf(out_asm, "\t CALL_(%s)\n",funcs[a].name);
		tokens++;
		if (!strcmp(*tokens,")"))
		{
			tokens++;
		}
		else
		{
			die("missing )");
		}
		if (!strcmp(*tokens,";"))
		{
			/* do nothing*/
			/* token automatically incremented later */;
		}
		else
		{
			die("missing ;\n");
		}
		}
	else
	{
		die("missing (\n");
	}
	return tokens;
}
/********************************************/
void parse(char *l)
{
	char**tokens;
	char**tmp;
	struct funcdef newfunc;
	struct variable newvar;
	char *str;
	int a,b,t;
	char *dst, *src;

	while (*l==' '||*l=='\t'||*l=='\n') l++;

	if (*l==0) return;

	tokens=split(l);

	if (tokens==NULL) return;

	tmp=tokens;
	if (verbosemode)
	{
		printf("%d tokens - ", tokencount);
		while (*tmp!=NULL)
		{
			printf("%s ", *tmp);
			tmp++;
		}
		printf("\n");
		tmp=tokens;
	}

	if (outputsource)
	{
		fprintf(out_asm, "\n; ZINC Source ----- ");
		while (*tmp!=NULL)
		{
			fprintf(out_asm, "%s ", *tmp);
			tmp++;
		}
		fprintf(out_asm,"\n");
	}

	tmp=tokens;
	while (*tokens!=NULL)
	{
		t = lookuptype(*tokens);
		if (t!=-1)
		{
			/*
			printf("variable : %s, type : %s = %d\n", *(tokens+1), *tokens, t);
			*/
			tokens++;
			if (!strcmp(*(tokens+1),"("))
			{
				newfunc.type=t;
				newfunc.name=malloc(1+strlen(*tokens));
				strcpy(newfunc.name,*tokens);
				newfunc.vcount=0;
				tokens+=2;
				if (!strcmp(newfunc.name,"main")) tokens++; /* skip past program name */
				while (strcmp(*tokens,")"))
				{
					if (!strcmp(*tokens,",")) tokens++;
					newvar.type=lookuptype(*tokens);
					if ((newvar.type>-1) && (newvar.type<VOID))
					{
						/*
						newvar.name=malloc(1+strlen(*tokens));
						strcpy(newvar.name,*tokens);
						*/
						newvar.name=malloc(1);
						strcpy(newvar.name,"");
						addvar2func(&newfunc,newvar);
						/*tokens++;*/
					}
					else
					{
						newfunc.vcount=0;
						newfunc.vars=NULL;
					}
					tokens++;
				}
#ifdef DEBUG
				printf("new function : %s\n", newfunc.name);
				printf("variables:\n");
				for (a=0;a!=newfunc.vcount;a++)
				{
					printf("\ttype : %s=%d, name : %s\n", vartypes[newfunc.vars[a].type],newfunc.vars[a].type, newfunc.vars[a].name);
				}
				getch();
#endif
				addfunc(newfunc);

				if (strcmp(*(tokens+1),";")) /* next token != ';' */
				{
					/* this is not just a definition */
					fprintf(out_asm,";+----------------\n");
					fprintf(out_asm,";| function %s\n", newfunc.name);
					fprintf(out_asm,";+----------------\n");
					fprintf(out_asm,"%s:\n",newfunc.name);
				}
				/* new */
				free(newfunc.name);
			}
			else
			{
				while (strcmp(*tokens,";")) /* *tokens != ; */
				{
					if (!strcmp(*tokens,",")) tokens++; /* skip commas */

					newvar.name=malloc(1+strlen(*tokens));
					strcpy(newvar.name, *tokens);
					newvar.type=t;

					if (verbosemode) printf("normal variable : %s\n", newvar.name);

					addvar(newvar);
					tokens++;
					free(newvar.name);
				}
			}
		}
		else if (!strcmp(*tokens,"{"))
		{
#ifdef DEBUG
			printf("{");
#endif
			labelcount++;
			fprintf(out_asm, "L%uOpen:\n", labelcount);
			opencount++;
		}
		else if (!strcmp(*tokens,"}"))
		{
			opencount--;
#ifdef DEBUG
			printf("}");
#endif
			fprintf(out_asm, "L%uClose:\n", labelcount-opencount);
		}
		else if (!strcmp(*tokens,"asm"))
		{
			tokens++;
			tokens++;
			str=malloc(1+strlen(*tokens));
			strcpy(str,*tokens);
			for (a=0;a<strlen(str);a++)
			{
				if (str[a]=='"')
					str[a]=' ';
			}
			fprintf(out_asm, "\t%s\n",str); /* inline asm */
			free(str);
			tokens++;
			if (strcmp(*tokens,")"))
			{
				die("unmatched parenthesis");
			}
			tokens++;
			if (strcmp(*tokens,";"))
			{
				die ("missing ;");
			}
		}
		else if (!strcmp(*tokens,"return"))
		{
			tokens++;
			if (strcmp(*tokens,";"))
			{
				/*
				setup register with return value
				assumes funcs[funccount-1] is current function
				*/
				if (!strcmp(*tokens,"(")) tokens++;
				fprintf (out_asm, "\t ld %s, %s\n", vartypes[funcs[funccount-1].type], *tokens);
				tokens++;
				if (!strcmp(*tokens,")")) tokens++;
				/*if (!strcmp(*tokens,";")) tokens++;*/
			}
			fprintf(out_asm,"\t ret\n");
		}
		else if ((*tokens)[strlen(*tokens)-1]==':') /* if last char is : assume its a label */
		{    /* this appears very, very complicated pointer shit */
			/* its really not */
			fprintf(out_asm,"%s\n", *tokens);
		}
		else if (!strcmp(*tokens,"goto"))
		{
			tokens++; /* move to label */
			fprintf(out_asm,"\t JUMP_(%s)\n", *tokens);
			tokens++;
			if (strcmp(*tokens,";"))
			{
				die("missing ;");
			}
		}
		else if (lookupvar(*tokens)!=-1)
		{
			t=lookupvar(*tokens);
#ifdef VIEW
			printf("variable : %s\n", *tokens);
#endif
			/*
			printf("variables are not yet parsed correctly\n");
			*/
			tokens++;
			if (!strcmp(*tokens,"="))
			{
				tokens++;
				if (**tokens=='"')
				{
					datacount++;

					fprintf(out_asm, "\t ld hl, (PROGRAM_ADDR)\n");
					fprintf(out_asm, "\t ld de, Data%d\n", datacount);
					fprintf(out_asm, "\t add hl, de\n");
					fprintf(out_asm, "\t ld %s, hl\n", variables[t].name);

					fprintf(out_dat, "Data%d:\n", datacount);
					fprintf(out_dat, ".db %s,0\n", *tokens);
					tokens++;
					if (strcmp(*tokens,";"))
					{
						die("missing ;");
					}
				}
				else if ((b=lookupfunc(*tokens))>-1) /* look up function */
				{     /*  ^^^^^^^^^^^^^^^^^^^^^ yes, thats correct single = */
#ifdef VIEW
					printf("function call %s\n", funcs[b].name);
#endif
					tokens=parsefunction(tokens);
					fprintf(out_asm,"\t ld %s, %s\n", variables[t].name, vartypes[funcs[b].type]);
				}
				else
				{
					a=z80sizeof(vartypes[variables[t].type]);
					if (a==2)
					{
						fprintf(out_asm, "\t ld hl, %s\n", *tokens);

						if (strcmp(variables[t].name,"hl"))
							fprintf(out_asm,"\t ld %s, hl\n",variables[t].name);
					}
					else
					{
						fprintf(out_asm, "\t ld a, %s\n", *tokens);
						if (strcmp(variables[t].name,"a"))
							fprintf(out_asm,"\t ld %s, a\n",variables[t].name);
					}
					tokens++;
				}
			}
			else
			{
				a=z80sizeof(vartypes[variables[t].type]);
				if (!strcmp(*tokens,"+"))
				{
					tokens++;
					if (!strcmp(*tokens,"="))
					{
						tokens++;
						if (a==2)
						{
							if (strcmp(variables[t].name,"hl"))
							{
								fprintf(out_asm, "\t ld hl, %s\n", variables[t].name);
								fprintf(out_asm, "\t adc hl, %s\n", *tokens);
								fprintf(out_asm, "\t ld %s, hl\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t adc hl, %s\n", *tokens);
							}
						}
						else
						{
							if (strcmp(variables[t].name,"a"))
							{
								fprintf(out_asm, "\t ld a, %s\n", variables[t].name);
								fprintf(out_asm, "\t adc a, %s\n", *tokens);
								fprintf(out_asm, "\t ld %s, a\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t adc a, %s\n", *tokens);
							}
						}
					}
					else if (!strcmp(*tokens, "+"))
					{
						tokens++;
						if (a==2)
						{
							if (isregister(variables[t].name))
							{
								fprintf(out_asm, "\t inc %s\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t ld hl, %s\n", variables[t].name);
								fprintf(out_asm, "\t inc hl\n");
								fprintf(out_asm, "\t ld %s, hl\n", variables[t].name);
							}
						}
						else /* a!=2 */
						{
							if (isregister(variables[t].name))
							{
								fprintf(out_asm, "\t inc %s\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t ld a, %s\n", variables[t].name);
								fprintf(out_asm, "\t inc a\n");
								fprintf(out_asm, "\t ld %s, a\n", variables[t].name);
							}
						}
					}
					else
					{
						die("unknown variable op\n");
					}
				}
				else if (!strcmp(*tokens,"-"))
				{
					tokens++;
					if (!strcmp(*tokens,"="))
					{
						tokens++;
						if (a==2)
						{
							if (strcmp(variables[t].name,"hl"))
							{
								fprintf(out_asm, "\t ld hl, %s\n", variables[t].name);
								fprintf(out_asm, "\t sbc hl, %s\n", *tokens);
								fprintf(out_asm, "\t ld %s, hl\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t sbc hl, %s\n", *tokens);
							}
						}
						else
						{
							if (strcmp(variables[t].name,"a"))
							{
								fprintf(out_asm, "\t ld a, %s\n", variables[t].name);
								fprintf(out_asm, "\t sbc a, %s\n", *tokens);
								fprintf(out_asm, "\t ld %s, a\n", variables[t].name);
							}
							else
							{
								fprintf(out_asm, "\t sbc a, %s\n", *tokens);
							}
						}
					}
					else if (!strcmp(*tokens,"-"))
					{
						if (isregister(variables[t].name))
						{
							fprintf(out_asm, "\t inc %s\n", variables[t].name);
						}
						else
						{
							switch (z80sizeof(variables[t].name))
							{
								case 2:
									fprintf(out_asm, "\t ld hl, %s\n", variables[t].name);
									fprintf(out_asm, "\t inc hl\n");
									fprintf(out_asm, "\t ld %s, hl\n", variables[t].name);
									break;
								case 1:
									fprintf(out_asm, "\t ld a, %s\n", variables[t].name);
									fprintf(out_asm, "\t inc a\n");
									fprintf(out_asm, "\t ld %s, a\n", variables[t].name);
									break;
								default:
									die("variable parse error");
									break;
							}
						}
					}
					else
					{
						die("unknown variable op");
					}
				}
				else if (!strcmp(*tokens,"*")||!strcmp(*tokens,"/"))
				{
					die("mult/div not currently implemented");
				}
				else
				{
					die("unknown variable operation");
				}
			}
			while (strcmp(*tokens,";")) tokens++;
		}
		else if (lookupfunc(*tokens)!=-1)
		{
			a=lookupfunc(*tokens);

			if (verbosemode) printf("function call : %s\n", *tokens);

			tokens++;
			if (!strcmp(*tokens,"("))
			{
				for (b=0;b<funcs[a].vcount;b++) /* get all parameters */
				{
					tokens++;
					if (!strcmp(*tokens,",")) tokens++;

					if (verbosemode) printf("\tparameter %d - %s\n", b, *tokens);

					t=funcs[a].vars[b].type;
					if (t==lookuptype("hl"))
					{
						fprintf(out_asm, "\t ld hl, %s\n", *tokens);
					}
					else if (t==lookuptype("a"))
					{
						fprintf(out_asm, "\t ld a, %s\n", *tokens);
					}
					else if (z80sizeof(funcs[a].vars[a].name)==2)
					{
						fprintf(out_asm, "\t ld hl, %s\n", *tokens);
						fprintf(out_asm, "\t ld %s, hl\n", vartypes[t]);
					}
					else /* assume its 1 byte*/
					{
						fprintf(out_asm, "\t ld a, %s\n", *tokens);
						fprintf(out_asm, "\t ld %s, a\n", vartypes[t]);

					}
				}
				fprintf(out_asm, "\t CALL_(%s)\n",funcs[a].name);
				tokens++;
				if (!strcmp(*tokens,")"))
				{
					tokens++;
				}
				else
				{
					die("missing )");

				}
				if (!strcmp(*tokens,";"))
				{
					/* do nothing*/
					/* token automatically incremented later */;
				}
				else
				{
					die("missing ;\n");
				}

			}
			else
			{
				die("missing (\n");
			}
		}
		else if (!strcmp(*tokens,"dw")||!strcmp(*tokens,"db"))
		{
			fprintf(out_asm, ".%s ", *tokens);
			tokens++;
			if (strcmp(*tokens,"("))
			{
				die("missing (");
			}
			tokens++;

			t=strlen(*tokens);
			**tokens=' ';    /* remove "*/
			*(*tokens+strlen(*tokens)-1)=' ';  /* remove "*/

			fprintf(out_asm, "%s\n", *tokens);

			tokens++;
			if (strcmp(*tokens,")"))
			{
				die("missing )\n\n");
			}
			tokens++;
		}
		else
		{
			printf("zinc.exe : token not understood : %s\n",*tokens);
		}
		tokens++;
	}

	for (a=0;a<tokencount;a++)
	{
		free(tmp[a]);
	}
	free(tmp);
	/*
	free(newfunc.name);
	free(newvar.name);
	*/

	fflush(out_asm);
	fflush(out_dat);
	return;
}
