/*
+----------------------------
| ZINC : ZINC Is Not C
|
| Pseudo C Programming for the TI-85
|
| Christopher Bowron - ai150@detroit.freenet.org
| Began on Aug 18, 1996
|
|
| DiGiTaL Dreamland MCMXCVI
+----------------------------
| I Saw The Best Minds Of My Generation Destroyed By Madness,
|              Starving, Hysterical Naked.
|                                       Allen Ginsberg
+----------------------------
| Genius Has Its Limits, But Stupidity Is Not Thus Handicapped.
+----------------------------
*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include "zinc.h"

char info[]=
	";+-------------\n"
	";| ZINC Version " ZINCVER " Output\n"
	";| ZINC Is Not C \n"
	";| Christopher Bowron / DiGiTaL Dreamland 1996\n"
	";| ai150@detroit.freenet.org\n"
	";+-------------\n"
	"\n"
	"#include ""ti-85.h\n"
	"\n";

char datainfo[]=
	";+-------------\n"
	";| ZINC (Is Not C) In Strings Variables\n"
	";+-------------\n"
	"\n";

char *vartypes[]=
{
	"hl", "af", "bc", "de",
	"a", "b","c", "d", "e", "f",
	"i", "ix", "iy", "pc", "r", "sp",
	"void", "char", "int", "pointer",0
};

struct funcdef * funcs;
int funccount=0;

struct variable * variables;
int varcount=0;

unsigned int freemem=0x80DF; /* textmem in calculator... 168 bytes */
int varmem=0;                  /* running count of our variables         */

FILE *in, *out_asm, *out_dat;

int labelcount=0;
int opencount=0;
int linecount=0;
int datacount=0;

int outputsource=0;
int quietmode=0;
int verbosemode=0;
/********************************************/
void die(char *s)
{
	printf("zinc.exe : line %d - %s\n\n", linecount, s);
	exit(255);
}
/********************************************/
int isregister(char *s)
{
	int t=lookuptype(s);
	if (t==-1)
		return 0;
	if (t<VOID)
		return 1;
	return 0;
}
/********************************************/
void addfunc(struct funcdef newfunc)
{
	struct funcdef *tmpfuncs;
	int a,b,i;

	tmpfuncs=funcs;

	funcs=(struct funcdef*)malloc((1+funccount)*sizeof(struct funcdef));
	for (i=0;i<funccount;i++)
	{
		memcpy(&funcs[i],&tmpfuncs[i],sizeof(tmpfuncs[i]));
	}

	funcs[funccount].name=malloc(strlen(newfunc.name)+1);
	strcpy(funcs[funccount].name,newfunc.name);
	funcs[funccount].type=newfunc.type;
	funcs[funccount].vcount=newfunc.vcount;
	funcs[funccount].vars=malloc(sizeof(newfunc.vars));

	for (a=0;a!=newfunc.vcount;a++)
	{
		funcs[funccount].vars[a].name=malloc(1+strlen(newfunc.vars[a].name));
		strcpy(funcs[funccount].vars[a].name,newfunc.vars[a].name);
		funcs[funccount].vars[a].type=newfunc.vars[a].type;
	}

	funccount++;

	free(tmpfuncs);
	return;
}
/********************************************/
void addvar(struct variable v)
{
	struct variable *tvars;
	int i;
	tvars=variables;
	variables=malloc((1+varcount)*sizeof(struct variable));
	for (i=0;i<varcount;i++)
	{
		variables[i].name=malloc(1+strlen(tvars[i].name));
		strcpy(variables[i].name,tvars[i].name);
		variables[i].type=tvars[i].type;
		free(tvars[i].name);
	}
	variables[varcount].name=malloc(1+strlen(v.name));
	strcpy(variables[varcount].name,v.name);
	variables[varcount].type=v.type;
	varcount++;
	/*free(tvars);*/
	switch (v.type)
	{

	case INT: /* int */
	case POINTER: /* pointer */
		fprintf(out_asm,";+----------------\n");
		fprintf(out_asm,";| variable %s\n", v.name);
		fprintf(out_asm,";| stored in TEXTMEM + %X\n", varmem);
		fprintf(out_asm,";+----------------\n");
		fprintf(out_asm, "#define %s ($%X)\n", v.name, freemem+varmem);
		varmem+=2; /* pointers and ints are 2 bytes */
		break;
	case CHAR:     /* char */
		fprintf(out_asm,";+----------------\n");
		fprintf(out_asm,";| variable %s\n", v.name);
		fprintf(out_asm,";| stored in TEXTMEM + %X\n", varmem);
		fprintf(out_asm,";+----------------\n");

		fprintf(out_asm, "%s = $%X\n", v.name, freemem+varmem);
		varmem+=1; /* chars are 1 byte */
		break;
	default:
		printf("zinc.exe : cannot create variable of type %s\n", vartypes[v.type]);
		exit(255);
		break;
	}
	if (varmem>168)
	{
		printf("zinc.exe : out of variable space in output\n");
		exit(255);
	}
	return;
}
/********************************************/
int lookupvar(char *v)
{
	int a;
	for (a=0;a<varcount;a++)
	{
		if (!strcmp(variables[a].name, v))
			return a;
	}
	return -1;
}
/********************************************/
int lookupfunc(char *f)
{
	int a;
	for (a=0;a<funccount;a++)
	{
		if (!strcmp(funcs[a].name, f))
			return a;
	}
	return -1;
}
/********************************************/
int lookuptype(char *s) /* return place in array of vartypes */
{
	int x;
	for (x=0;;x++)
	{
		if (vartypes[x]==0)
			return -1;
		if (!strcmp(vartypes[x],s))
			return x;
	}
}
/********************************************/
char *z80typeof(char *s)
{
	int a;
	a=lookupvar(s);
	return (vartypes[variables[a].type]);
}
/********************************************/
int z80sizeof(char *st)
{
	char *s=z80typeof(st);
	if (!strcmp(s,"int")) return 2;
	if (!strcmp(s,"pointer")) return 2;
	if (!strcmp(s,"char")) return 1;
	return strlen(s);
}
/********************************************/
int setupfile(void)
{
	fprintf(out_asm, info);
	return 0;
}
/********************************************/
void setupdatfile(void)
{
	fprintf(out_dat, datainfo);
	return ;
}
/********************************************/
void addvar2func(struct funcdef *func, struct variable v)
{
	struct funcdef tf;
	struct funcdef f=*func;
	int i;
	tf.vars=func->vars;
	f.vars=malloc((f.vcount+1)*sizeof(struct variable));
	for (i=0;i<f.vcount;i++)
	{
		f.vars[i].name=malloc(1+strlen(tf.vars[i].name));
		strcpy(f.vars[i].name,tf.vars[i].name);
		f.vars[i].type=tf.vars[i].type;
		/*free(tf.vars[i].name);*/
	}
	func->vars[f.vcount].name=malloc(1+strlen(v.name));
	strcpy(func->vars[f.vcount].name, v.name);
	func->vars[f.vcount].type=v.type;
	func->vcount++;
	return;
}
/********************************************/
void setupname(void)
{
	char *line;
	char *substr, *p;
	char **spl;
	line = malloc(256);
	for (;;)
	{
		memset(line,0,256);
		fgets(line,256,in);
		substr = strstr(line, "main");
		if (substr)
		{
			substr+=6;
			for (p=substr;*p!='"';p++)
				/* Do Nothing */;
			*p=0;
			fprintf(out_asm, ".org 0\n");
			fprintf(out_asm, ".db %c%s%c,0\n", '"',substr,'"');
			fprintf(out_asm,
			"\n"
			"ProgStart:\n"
			"\tCALL_(main)\n"
			"\tret\n"
			);
		}
		if (substr)
			break;
		if (feof(in))
		{
			printf("zinc.exe : main() not found\n\n");
			exit(255);
		}
	}
	free(line);
}
/********************************************/
/*
+-----------------
| create variables for all the registers
| zero out all counters
+-----------------
*/
void setupvars(void)
{
	int a,t;

	varcount=0;
	funccount=0;
	freemem=0x80DF; /* textmem in calculator... 168 bytes */
	varmem=0;                 /* running count of our variables         */

	labelcount=0;
	opencount=0;
	linecount=0;
	datacount=0;

	variables=(struct variable*)malloc(25*sizeof(struct variable));
	for (a=0;;a++)
	{
		if (!strcmp(vartypes[a],"void"))
			break;
		t=lookuptype(vartypes[a]);
		if (a!=t)
			break;
		variables[varcount].name=malloc(1+strlen(vartypes[a]));
		if (variables[varcount].name==NULL)
		{
			printf("zinc.exe : out of memory\n\n");
			exit(255);
		}
		strcpy(variables[varcount].name,vartypes[a]);
		variables[varcount].type=t;
		varcount++;
#ifdef DEBUG
		printf("%s : type %s = %d\n", variables[a].name, vartypes[variables[a].type], variables[a].type);
#endif
	}
#ifdef DEBUG
	getch();
#endif
	return;
}
/********************************************/
void releasevars(void)
{
	int a,b;
	for (a=0;a<varcount;a++)
	{
		free(variables[a].name);
	}
	free(variables);
	for (a=0;a<funccount;a++)
	{
		free(funcs[a].vars);
		free(funcs[a].name);
	}
	free(funcs);
}
/********************************************/
void printinfo(void)
{
	char out[]=
	"ZINC (ZINC Is Not C) Version " ZINCVER "\n"
	"(C) 1996 Christopher Bowron / DiGiTaL Dreamland\n"
	"see ZINC.DOC and COPYING for more details\n"
	"\n";

	printf("%s", out);
	return;
}
/********************************************/
void printvars(void)
{
	int a;
	for (a=0;a<varcount;a++)
	{
		printf("var %s : type %s\n", variables[a].name, vartypes[variables[a].type]);
	}
	return;
}
/********************************************/
int main(int argc, char **argv)
{
	int meminfo=1;
	int detailedmeminfo=0;
	char *line;

	if (argc<2)
	{
		char idiot[]=
		{
		"zinc.exe : no input files\n"
		"\n"
		"usage:\n"
		"	zinc.exe [-options] infile\n\n"
		"options:\n"
		"	-s		output source in zinc_out.asm\n"
		"	-q		quiet mode (no screen output)\n"
		"	-v		verbose mode\n"
		};
		printinfo();
		printf("%s", idiot);
		exit(255);
	}

	++argv;

	for (;argc>1;argc--)
	{
		if (**argv!='-')
			break;

		switch(*(*argv+1))
		{
			case 's':
				outputsource=1;
				break;
			case 'q':
				quietmode=1;
				break;
			case 'v':
				verbosemode=1;
				break;
			case 'm':
				meminfo=1;
				break;
			case 'M':
				meminfo=0;
				break;
			case 'd':
				detailedmeminfo=1;
				break;
			default:
				printinfo();
				printf("zinc.exe : unknown option - %s\n", *argv);
				exit(255);
				break;
		}
		argv++;
	}
	if (!quietmode)	printinfo();

	in=fopen(argv[0],"r");
	out_asm=fopen("zinc_out.asm","w+");
	out_dat=fopen("zinc_out.dat","w+");

	if (!quietmode) printf("converting %s to %s\n", *argv, "zinc_out.asm");

	if (!quietmode&&meminfo)
		printf("free heap memory : %u\n", coreleft());

	setupfile();
	setupdatfile();
	setupvars();

	if (in==NULL)
	{
		printf("zinc.exe : file not found\n\n");
		exit(255);
	}
	line=malloc(256);
	if (line==NULL)
	{
		printf("zinc.exe : out of memory\n\n");
		exit(255);
	}

	fseek(in,SEEK_SET,0);
	setupname();
	fseek(in,SEEK_SET,0);

	for (;;)
	{
		linecount++;
		if (detailedmeminfo)
			printf("line %u : freemem = %u\n", linecount, coreleft());
		strcpy(line,"");
		fgets(line,255,in);
		if (line==NULL)
			break;
		if (feof(in))
			break;
		parse(line);
	}

	fprintf(out_dat, "\n\n.end	; required by tasm\n");

	if (!quietmode) printf("pass 1 complete\n");

	fseek(out_dat, 0, SEEK_SET);
	for (;;)
	{
		strcpy(line,"");
		fgets(line,255,out_dat);
		if (line==NULL)
			break;
		if (feof(out_dat))
			break;
		fprintf(out_asm, "%s", line);
	}
	free(line);
#ifdef DEBUG
	printvars();
#endif
	fclose(in);
	fclose(out_asm);
	fclose(out_dat);
	remove("zinc_out.dat");
	if (!quietmode) printf("pass 2 complete\n");
	/*
	I plan to make third pass compiler that checks for redundant loads
	*/
	if (!quietmode) printf("pass 3 not implemented yet (optimize pass)\n");

	releasevars();
	if (!quietmode&&meminfo)
		printf("free heap memory : %u\n", coreleft());

	if (!quietmode) printf("done\n\n");
	exit(0);
	return 0;
}
